package ProxyBwapi.Races

import ProxyBwapi.Techs.Techs
import ProxyBwapi.UnitClasses.UnitClasses
import ProxyBwapi.Upgrades.Upgrades
import bwapi.{TechType, UnitType, UpgradeType}

object Protoss {
  lazy val Probe                = UnitClasses.get(UnitType.Protoss_Probe)
  lazy val Zealot               = UnitClasses.get(UnitType.Protoss_Zealot)
  lazy val Dragoon              = UnitClasses.get(UnitType.Protoss_Dragoon)
  lazy val HighTemplar          = UnitClasses.get(UnitType.Protoss_High_Templar)
  lazy val Archon               = UnitClasses.get(UnitType.Protoss_Archon)
  lazy val DarkTemplar          = UnitClasses.get(UnitType.Protoss_Dark_Templar)
  lazy val DarkArchon           = UnitClasses.get(UnitType.Protoss_Dark_Archon)
  lazy val Shuttle              = UnitClasses.get(UnitType.Protoss_Shuttle)
  lazy val Reaver               = UnitClasses.get(UnitType.Protoss_Reaver)
  lazy val Scarab               = UnitClasses.get(UnitType.Protoss_Scarab)
  lazy val Observer             = UnitClasses.get(UnitType.Protoss_Observer)
  lazy val Scout                = UnitClasses.get(UnitType.Protoss_Scout)
  lazy val Corsair              = UnitClasses.get(UnitType.Protoss_Corsair)
  lazy val Carrier              = UnitClasses.get(UnitType.Protoss_Carrier)
  lazy val Interceptor          = UnitClasses.get(UnitType.Protoss_Interceptor)
  lazy val Arbiter              = UnitClasses.get(UnitType.Protoss_Arbiter)
  lazy val Nexus                = UnitClasses.get(UnitType.Protoss_Nexus)
  lazy val Pylon                = UnitClasses.get(UnitType.Protoss_Pylon)
  lazy val Assimilator          = UnitClasses.get(UnitType.Protoss_Assimilator)
  lazy val Forge                = UnitClasses.get(UnitType.Protoss_Forge)
  lazy val ShieldBattery        = UnitClasses.get(UnitType.Protoss_Shield_Battery)
  lazy val PhotonCannon         = UnitClasses.get(UnitType.Protoss_Photon_Cannon)
  lazy val Gateway              = UnitClasses.get(UnitType.Protoss_Gateway)
  lazy val CyberneticsCore      = UnitClasses.get(UnitType.Protoss_Cybernetics_Core)
  lazy val RoboticsFacility     = UnitClasses.get(UnitType.Protoss_Robotics_Facility)
  lazy val RoboticsSupportBay   = UnitClasses.get(UnitType.Protoss_Robotics_Support_Bay)
  lazy val Observatory          = UnitClasses.get(UnitType.Protoss_Observatory)
  lazy val Stargate             = UnitClasses.get(UnitType.Protoss_Stargate)
  lazy val FleetBeacon          = UnitClasses.get(UnitType.Protoss_Fleet_Beacon)
  lazy val CitadelOfAdun        = UnitClasses.get(UnitType.Protoss_Citadel_of_Adun)
  lazy val TemplarArchives      = UnitClasses.get(UnitType.Protoss_Templar_Archives)
  lazy val ArbiterTribunal      = UnitClasses.get(UnitType.Protoss_Arbiter_Tribunal)
  lazy val SpellDisruptionWeb   = UnitClasses.get(UnitType.Spell_Disruption_Web)
  lazy val GroundDamage         = Upgrades.get(UpgradeType.Protoss_Ground_Weapons)
  lazy val GroundArmor          = Upgrades.get(UpgradeType.Protoss_Ground_Armor)
  lazy val AirDamage            = Upgrades.get(UpgradeType.Protoss_Air_Weapons)
  lazy val AirArmor             = Upgrades.get(UpgradeType.Protoss_Air_Armor)
  lazy val Shields              = Upgrades.get(UpgradeType.Protoss_Plasma_Shields)
  lazy val DragoonRange         = Upgrades.get(UpgradeType.Singularity_Charge)
  lazy val ZealotSpeed          = Upgrades.get(UpgradeType.Leg_Enhancements)
  lazy val ShuttleSpeed         = Upgrades.get(UpgradeType.Gravitic_Drive)
  lazy val ScarabDamage         = Upgrades.get(UpgradeType.Scarab_Damage)
  lazy val ReaverCapacity       = Upgrades.get(UpgradeType.Reaver_Capacity)
  lazy val ObserverSpeed        = Upgrades.get(UpgradeType.Gravitic_Boosters)
  lazy val ObserverVisionRange  = Upgrades.get(UpgradeType.Sensor_Array)
  lazy val ScoutSpeed           = Upgrades.get(UpgradeType.Gravitic_Thrusters)
  lazy val ScoutVisionRange     = Upgrades.get(UpgradeType.Apial_Sensors)
  lazy val CarrierCapacity      = Upgrades.get(UpgradeType.Carrier_Capacity)
  lazy val HighTemplarEnergy    = Upgrades.get(UpgradeType.Khaydarin_Amulet)
  lazy val DarkArchonEnergy     = Upgrades.get(UpgradeType.Argus_Talisman)
  lazy val CorsairEnergy        = Upgrades.get(UpgradeType.Argus_Jewel)
  lazy val ArbiterEnergy        = Upgrades.get(UpgradeType.Khaydarin_Core)
  lazy val PsionicStorm         = Techs.get(TechType.Psionic_Storm)
  lazy val Hallucination        = Techs.get(TechType.Hallucination)
  lazy val ArchonMeld           = Techs.get(TechType.Archon_Warp)
  lazy val DarkArchonMeld       = Techs.get(TechType.Dark_Archon_Meld)
  lazy val Feedback             = Techs.get(TechType.Feedback)
  lazy val Maelstrom            = Techs.get(TechType.Maelstrom)
  lazy val MindControl          = Techs.get(TechType.Mind_Control)
  lazy val DisruptionWeb        = Techs.get(TechType.Disruption_Web)
  lazy val Recall               = Techs.get(TechType.Recall)
  lazy val Stasis               = Techs.get(TechType.Stasis_Field)

  lazy val FenixDragoon = UnitClasses.get(UnitType.Hero_Fenix_Dragoon)
}



